<?php

namespace AMZcockpitDoctrine\Repository;
use AMZcockpitDoctrine\Entity\MWS\Orders;
use AMZcockpitDoctrine\Entity\Email;
use Doctrine\Common\Collections\ArrayCollection;
use AMZcockpitDoctrine\Entity\User;

/**
 * EmailRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class EmailRepository extends \Doctrine\ORM\EntityRepository
{
    public function getActiveEmailByEvent(Orders $order, $status) {

        $user = $order->getStore()->getUser();
        $items = $order->getItems();
        $marketPlaceId = $order->getMarketplaceId();
        $date  = new \DateTime('now');
        $productsIds = [];
        foreach ($items as $item)
        {
            if(!is_null($item->getProduct()))
                $productsIds[] = $item->getProduct()->getId();
        }

        $qb = $this->createQueryBuilder('e')->select('e');
        $qb->where('e.user = :user')->setParameter('user', $user);
        $qb->andWhere($qb->expr()->like('e.marketPlaces',':marketPlace'))->setParameter('marketPlace','%'.$marketPlaceId.'%');
        $qb->andWhere($qb->expr()->eq('e.enabled',':enabled'))->setParameter('enabled',true);
        if(is_array($status)) {
            $qb->andWhere($qb->expr()->in('e.deliveryEvent', ':status'))->setParameter('status',$status);
        } else {
            $qb->andWhere($qb->expr()->eq('e.deliveryEvent', ':status'))->setParameter('status',$status);
        }

        $qb->leftJoin('e.products','p');
        $qb->andWhere(
            $qb->expr()->orX(
                $qb->expr()->in('p.id',':products'),
                $qb->expr()->eq('e.selectAllProducts',':selectAllProducts')
            )
        )
        ->setParameter('selectAllProducts',true)
        ->setParameter('products',$productsIds);

        $qb->andWhere(
            $qb->expr()->orX(
                $qb->expr()->isNull('e.orderAfterDate'),
                $qb->expr()->andX(
                    $qb->expr()->isNotNull('e.orderAfterDate'),
                    $qb->expr()->gte(':date','e.orderAfterDate')
                )
            )
        )->setParameter('date',$date);
        return  $qb->getQuery()->getResult();
    }
}
